<?php
/**************************************************************

SaveImage 1.0

Developed by Paul Burney
Web: paulburney.com
AIM: PWBurney
E-mail: support@paulburney.com

***************************************************************

functions.php

This file contains the functions used by the CCVault system.

**************************************************************/

function si_array_remove_empty($arr = array()) {

	$new = array();
	
	for ($i = 0; $i < count($arr); $i++) {
	
		if ($arr[$i] != '') {
			$new[] = $arr[$i];
		}
	
	}
	
	return $new;

}

function si_db_connect() {

	// This function connects to the database, and saves the resource in static variable
	
	global $si_config;
	
	static $dbh;
	
	if (isset($dbh)) {
		return $dbh;
	}
	
	// connect to the database
	
	$dbh = mysql_pconnect($si_config['host'], $si_config['user'], $si_config['password']);
	mysql_select_db($si_config['database'], $dbh);

	return $dbh;

}

function si_db_select_query($query) {

	// This function performs a SELECT query with parameters and returns all results

	$result_array = array();

	$dbh = si_db_connect();
	
	$result = mysql_query($query, $dbh);
	
	if (mysql_error() == '') {
		if (mysql_num_rows($result) > 0) {
			while ($row = mysql_fetch_assoc($result)) {
				$result_array[] = $row;
			}
		}
	} else {
		trigger_error('ERR: Database query problem - ' . mysql_errno() . ': ' . mysql_error(), E_USER_WARNING);
	}
	
	return $result_array;

}

function si_db_insert_query($table, $data) {

	// This function performs a INSERT query with parameters and returns all results

	$dbh = si_db_connect();
	
	$query = 'INSERT INTO ' . $table;
	
	$data_parts = array();
	
	if (count($data) > 0) {
		
		reset($data);
		
		while (list($key, $value) = each($data)) {
		
			$data_parts[] = $key . '="' . mysql_real_escape_string(stripslashes($value), $dbh) . '"';
		
		}
		
		if (count($data_parts) > 0) {
		
			$query .= ' SET ' . implode(', ', $data_parts);
		
		}
		
	}
	
	$result = mysql_query($query, $dbh);
	
	if (mysql_error() == '') {
		return mysql_insert_id();
	} else {
		trigger_error('ERR: Database query problem - ' . mysql_errno() . ': ' . mysql_error(), E_USER_WARNING);
		return 0;
	}
	
}

function si_db_update_query($table, $data, $condition) {

	// This function performs a INSERT query with parameters and returns all results

	$dbh = si_db_connect();
	
	$query = 'UPDATE ' . $table;
	
	$data_parts = array();
	
	if (count($data) > 0) {
		
		reset($data);
		
		while (list($key, $value) = each($data)) {
		
			$data_parts[] = $key . '="' . mysql_real_escape_string($value, $dbh) . '"';
		
		}
		
		if (count($data_parts) > 0) {
		
			$query .= ' SET ' . implode(', ', $data_parts);
		
		}
		
	}
	
	$query .= ' WHERE ' . $condition;
	
	$result = mysql_query($query, $dbh);
	
	$ar = mysql_affected_rows($dbh);
	
	if (mysql_error() == '') {
		if ($ar == 0) {
			return -1;
		} else {
			return $ar;
		}
	} else {
		trigger_error('ERR: Database query problem - ' . mysql_errno() . ': ' . mysql_error(), E_USER_WARNING);
		return 0;
	}
	
}

function si_generate_error($message) {

	// this function displays an error message to the user

	header('Content-type: text/plain');
	echo 'ERR: ' . $message;
	exit;

}

function si_do_ping() {

	// this function returns true if the system is functional
	
	header('Content-type: text/plain');
	echo 'TRUE';
	exit;

}

function si_convert_path_to_id($path) {

	// this function prepares an id from a url looking item,
	// i.e., /78.jpg -> 78

	// remove the beginning slash
	$path = preg_replace('~^/~', '', $path);
	
	// remove the trailing extension
	$path = preg_replace('~\..*$~', '', $path);
	
	return $path;

}

function si_get_image($image_id) {

	// this function gets the image data for a particular image
	
	$query = 'SELECT image_type, image_data FROM images WHERE image_id="' . $image_id . '"';
	
	$images = si_db_select_query($query);
	
	if (count($images) == 0) {
	
		si_generate_error('Image not found');
	
	}
	
	$images[0]['image_type'];
	
	if ($images[0]['image_type'] == '') {
		$images[0]['image_type'] = 'application/octet-stream';
	}
	
	header('Content-type: ' . $images[0]['image_type']);

	echo $images[0]['image_data'];

}

function si_get_cohort_list($datestring, $organization_id = '') {

	// This function gets a list of all cohorts running on the specified date
	
	if ($datestring == 'today') {
	
		$datestring = date('Y-m-d');
	
	}
	
	if ($organization_id == '') {
	
		$organization_id = '3';
	
	}
	
	$query = 'SELECT cohort_id, cohort_name FROM cohorts';
	
	$where = ' WHERE ';
	
	if ($datestring != '') {
	
		 $query .= $where . ' cohort_start <= "' . $datestring . '" AND cohort_end >= "' . $datestring . '"';
		 
		 $where = '';
	
	}
	
	$query .= $where . ' organization_id="' . $organization_id . '"';
	
	$query .= ' ORDER BY cohort_name';
	
	$cohorts = si_db_select_query($query);
	
	if (count($cohorts) == 0) {
	
		si_generate_error('No Cohorts Found');
	
	}
	
	header('Content-type: text/plain');
	for ($i = 0; $i < count($cohorts); $i++) {
	
		echo $cohorts[$i]['cohort_id'] . "\t" . $cohorts[$i]['cohort_name'] . "\n";
	
	}

}

function si_save_image($cohort, $organization, $username, $title, $comments, $image_file) {

	// this function saves an image to the database.  On success, it returns the image id
	
	$errors = array();
	
	if ($cohort == '') {
		$errors[] = 'Cohort not specified.';
	}

	if ($username == '') {
		$errors[] = 'Username not specified.';
	}

	if ($title == '') {
		$errors[] = 'Title not specified.';
	}

	if ($image_file == '') {
		$errors[] = 'No image sent.';
	}
	
	if ($_FILES['image']['error'] > 0) {
		$errors[] = 'Image upload failed (' . $_FILES['image']['error'] . ')';
	}
	
	if (!is_uploaded_file($image_file)) {
		$errors[] = 'Uploaded file is not valid';
	}

	if ($organization == '') {
		
		// lookup organization from cohort
		$query = 'SELECT organization_id FROM cohorts WHERE cohort_id="' . $cohort . '"';
		$results = si_db_select_query($query);
		
		$organization = $results[0]['organization_id'];
		
	}
	
	if ($organization == '') {
		$organization = '1';
	}

	
	// check for any errors before continuing
	
	if (count($errors) > 0) {
	
		si_generate_error(implode('; ', $errors));
	
	}
	
	// setup image extensions
	$image_extensions = array();
	$image_extensions['image/gif'] = '.gif';
	$image_extensions['image/jpg'] = '.jpg';
	$image_extensions['image/jpeg'] = '.jpg';
	$image_extensions['image/png'] = '.png';
	
	// prepare to put data in the database

	$data = array();
	
	$data['image_title'] = $title;
	$data['image_comments'] = $comments;
	$data['user_name'] = $username;
	$data['cohort_id'] = $cohort;
	$data['image_data'] = addslashes(fread(fopen($image_file, 'rb'), filesize($image_file)));
	$data['image_type'] = $_FILES['image']['type'];
	$data['image_extension'] = $image_extensions[$data['image_type']];

	$image_id = si_db_insert_query('images', $data);
	
	$image_url = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'] . '/' . $image_id . $data['image_extension'];
	
	$group_url = 'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'] . '?action=browse&organizationid=' . $organization . '&cohortid=' . $cohort . '';
	
	header('Content-type: text/plain');
	echo $image_id . "\t" . $image_url . "\t" . $group_url ."\n";

}

function si_get_organization_name($organization_id) {

	$query = 'SELECT organization_name FROM organizations WHERE organization_id="' . $organization_id . '"';
	$results = si_db_select_query($query);
	
	return $results[0]['organization_name'];

}

function si_get_cohort_name($cohort_id) {

	$query = 'SELECT cohort_name FROM cohorts WHERE cohort_id="' . $cohort_id . '"';
	$results = si_db_select_query($query);
	
	return $results[0]['cohort_name'];

}

function si_get_organization_id_from_cohort_id($cohort_id) {

	$query = 'SELECT organization_id FROM cohorts WHERE cohort_id="' . $cohort_id . '"';
	$results = si_db_select_query($query);
	
	return $results[0]['organization_id'];

}


function si_display_organization_list() {

	echo '
	<h1>Select an organization:</h1>
	<ul>
	';
	
	$query = 'SELECT * FROM organizations ORDER BY organization_name';
	$results = si_db_select_query($query);
	
	for ($i = 0; $i < count($results); $i++) {
	
		echo '
		<li><a href="' . $_SERVER['SCRIPT_NAME'] . '?action=browse&organizationid=' . $results[$i]['organization_id'] . '">' . $results[$i]['organization_name'] . '</a></li>
		';
	
	}
	
	echo '
	</ul>
	';

}

function si_display_cohort_list($organization_id) {

	echo '
	<h1>' . si_get_organization_name($organization_id) . '</h1>
	
	<h2>Select a cohort or group:</h2>
	
	<ul>
	';
	
	$query = 'SELECT * FROM cohorts WHERE organization_id="' . $organization_id . '" ORDER BY cohort_name';
	$results = si_db_select_query($query);
	
	for ($i = 0; $i < count($results); $i++) {
	
		echo '
		<li><a href="' . $_SERVER['SCRIPT_NAME'] . '?action=browse&organizationid=' . $organization_id . '&cohortid=' . $results[$i]['cohort_id'] . '">' . $results[$i]['cohort_name'] . '</a></li>
		';
	
	}
	
	echo '
	</ul>
	
	<p><small><a href="' . $_SERVER['SCRIPT_NAME'] . '?action=browse">Return to Organization List</a></small></p>
	';

}

function si_display_image_list($cohort_id) {

	$organization_id = si_get_organization_id_from_cohort_id($cohort_id);
	$organization_name = si_get_organization_name($organization_id);

	$extra_params = '';
	
	if (@$_REQUEST['view'] != 'all') {
		$extra_params = ' AND image_datetime > DATE_SUB(NOW(), INTERVAL 1 MONTH)';
	}
	
	$query = 'SELECT *,DATE_FORMAT(image_datetime, "%Y-%m-%d %H:%i:%s") AS formatted_date FROM images WHERE cohort_id="' . $cohort_id . '" ' . $extra_params . ' ORDER BY image_datetime DESC';
	$results = si_db_select_query($query);
	
	echo '
	<h1>' . $organization_name . ' -&gt; ' . si_get_cohort_name($cohort_id) . '</h1>
	';
	
	if (count($results) > 0) {
	
		echo '
		<h2>Select an image:</h2>
	
		<table cellpadding="5" border="1" cellspacing="0" id="theList">
		<thead>
		<tr>
		<th>ID&nbsp;&nbsp;&nbsp;<a href="javascript:sortTable(\'theList\',0,true,\'number\');">↑</a>&nbsp;<a href="javascript:sortTable(\'theList\',0,false,\'number\');">↓</a></th>
		<th>Title&nbsp;&nbsp;&nbsp;<a href="javascript:sortTable(\'theList\',1,true,\'text\');">↑</a>&nbsp;<a href="javascript:sortTable(\'theList\',1,false,\'text\');">↓</a></th>
		<th>Comments&nbsp;&nbsp;&nbsp;<a href="javascript:sortTable(\'theList\',2,true,\'text\');">↑</a>&nbsp;<a href="javascript:sortTable(\'theList\',2,false,\'text\');">↓</a></th>
		<th>Username&nbsp;&nbsp;&nbsp;<a href="javascript:sortTable(\'theList\',3,true,\'text\');">↑</a>&nbsp;<a href="javascript:sortTable(\'theList\',3,false,\'text\');">↓</a></th>
		<th>Date&nbsp;&nbsp;&nbsp;<a href="javascript:sortTable(\'theList\',4,true,\'text\');">↑</a>&nbsp;<a href="javascript:sortTable(\'theList\',4,false,\'text\');">↓</a></th>
		<th>&nbsp;</th>
		</tr>
	
		</thead>
		<tbody>
	
		';
		
		for ($i = 0; $i < count($results); $i++) {
		
			echo '
			<tr>
			<td valign="top">' . $results[$i]['image_id'] . '</td>
			<td valign="top">' . $results[$i]['image_title'] . ' </td>
			<td valign="top">' . $results[$i]['image_comments'] . ' </td>
			<td valign="top">' . $results[$i]['user_name'] . '</td>
			<td valign="top">' . $results[$i]['formatted_date'] . '</td>
			<td valign="top"><a href="' . $_SERVER['SCRIPT_NAME'] . '/' . $results[$i]['image_id'] . '' . $results[$i]['image_extension'] . '">view</a></td>
			</tr>
			';
		
		}
		
		echo '
		</table>
		';
	
	} else {
	
		echo '<p>No images found</p>';
	
	}

	echo '
	<p><small><a href="' . $_SERVER['SCRIPT_NAME'] . '?action=browse">Return to Organization List</a> | <a href="' .  $_SERVER['SCRIPT_NAME'] . '?action=browse&organizationid=' . $organization_id . '">Return to ' . $organization_name . ' Cohort List</a></small></p>

	';

}


?>
