<?php
/**************************************************************

SaveImage 1.0

Developed by Paul Burney
Web: paulburney.com
AIM: PWBurney
E-mail: support@paulburney.com

***************************************************************

index.php

This file is called by the web user and should be the only
file allowed to be called directly.  It serves as the 
configuration loader and the controller.

**************************************************************/

/******* SETUP INCLUDE PATH CORRECTLY ********/

// Determine where this file is
$foundation_location = dirname(__FILE__);
$current_include_path = ini_get('include_path');
$pathdivider = ':';

// possible ways it could be listed in the include_path, at beginning or end
$re1 = '~' . $foundation_location . $pathdivider . '~';
$re2 = '~' . $pathdivider . $foundation_location . '~';

// only add the this directory to the path if it isn't alreday there
if (!preg_match($re1, $current_include_path) && !preg_match($re2, $current_include_path) && $current_include_path != $foundation_location) {
	$new_include_path = $foundation_location . $pathdivider . $current_include_path;
	ini_set('include_path', $new_include_path); 
}

/****** PERFORM SETUP WORK ********/

// Include necessary config files, libraries, etc.
include_once 'includes/config.php';
include_once 'includes/functions.php';

// setup error reporting
ini_set('error_reporting', $si_config['reporting_level']);

// Call the appropriate function based on the requested action

switch (@$_REQUEST['action']) {

	case 'ping':
	
		si_do_ping();
	
	break;
	
	case 'saveimage':
	
		si_save_image(@$_REQUEST['cohortid'], @$_REQUEST['organizationid'], @$_REQUEST['username'], @$_REQUEST['title'], @$_REQUEST['comments'], @$_FILES['image']['tmp_name']);
	
	break;
	
	case 'cohort':
	
		si_get_cohort_list(@$_REQUEST['date'], @$_REQUEST['organizationid']);
	
	break;
	
	case 'search':

	
	
	break;
	
	case 'browse':

		header('Content-type: text/html');

		echo $header;
			
		if (@$_REQUEST['organizationid'] == '') {
		
			si_display_organization_list();
		
		} else {
		
			if (@$_REQUEST['cohortid'] == '') {
			
				si_display_cohort_list($_REQUEST['organizationid']);
			
			} else {
			
				si_display_image_list($_REQUEST['cohortid']);
			
			}
		
		}
		
		echo $footer;
	
	break;

	default:
	
		if (isset($_SERVER['PATH_INFO'])) {

			si_get_image(si_convert_path_to_id($_SERVER['PATH_INFO']));
		
		} else {
				
			si_generate_error('No Action Specified');
		
		}
	
	break;

}

?>
